import java.util.*;

public class BSTTest {
static final int MAX = 10000;
static final int NINS = 100;

	public static void main(String args[]) {
	int h = 0; /* altezza dell'albero */
	int val = 0, val1 = 0, val2 = 0;
	myBSTree albero;
	BSTNode u, v;
	Random gen;

		gen = new Random();
		albero = new myBSTree();

		/* Popola albero con NINS nodi con chiavi casuali scelte 
		nell'intervallo [0..MAX] */

		/* Calcola altezza dell'albero -> h */

		System.out.println("Altezza albero : " + albero.treeHeight());

		/* Inserire due nodi con chiavi casuali e diverse nell'albero. 
		Essi sono u e v */

		val1 = gen.nextInt(MAX);
		albero.insert(new BaseObject(val1));
		do 
			val2 = gen.nextInt(MAX);
		while (val2 == val1);
		albero.insert(new BaseObject(val2));
		u = albero.search(new BaseObject(val1));
		v = albero.search(new BaseObject(val2));

		/* Stampare la chiave di lca(u, v) */

		System.out.println("Chiave u: " + u.key.toString());
		System.out.println("Chiave v: " + v.key.toString());
		BSTNode lcaNode = albero.lca(u, v);
		if (lcaNode != null)
			System.out.println("Chiave LCA: " + lcaNode.key.toString());
		
		/* Stampare no. chiavi comprese tra u.key e v.key */

		if (lcaNode != null)
			System.out.println("No. chiavi comprese in [" + val1 + ".." + val2 + "]: " + albero.nrange(u, v));
	}
}
		