
public class myBSTree extends BSTree {
private BSTree myBST;

	/* costruttore */
	public myBSTree() {
		
		myBST = new BSTree();
	}

	/* metodi */

	public BSTNode lca(BSTNode u, BSTNode v) {
	BSTNode temp = null;

		if (u.key.compareTo(v.key) > 0)
			return lca(v, u);
		temp = root();
		while ((temp.key.compareTo(u.key) < 0)||(temp.key.compareTo(v.key) > 0)) 
			if (temp.key.compareTo(u.key) < 0) 
				temp = temp.rightChild;
			
			else 
				temp = temp.leftChild;
		return temp;
	}

	/* public BSTNode lca(BSTNode u, BSTNode v) {
		 restituisce lca di u e v 
		return null;
	} */

	public int nrange(BSTNode u, BSTNode v) {
	BSTNode w;
	Comparable upper, lower;

		w = lca(u, v);
		if (u.key.compareTo(v.key) <= 0) {
			lower = u.key;
			upper = v.key;
		}
		else {
			lower = v.key;
			upper = u.key;
		}
		return lcaVisit(w, lower, upper); /* visita simmetrica modificata */
	}

	private int lcaVisit(BSTNode w, Comparable lower, Comparable upper) {
	int nchiavi = 0; /* No. chiavi nell'intervallo */

		if (w == null) /* sottoalbero vuoto */
			return 0;
		if (w.key.compareTo(lower) < 0)
		/* non possono esserci chiavi appartenenti all'
		intervallo nel sottoalbero sx ma forse nel dx */
			return lcaVisit(w.rightChild, lower, upper);

		/* non possono esserci chiavi appartenenti all'
		intervallo nel sottoalbero dx ma forse nel sx */
		if (w.key.compareTo(upper) > 0)
			return lcaVisit(w.leftChild, lower, upper);

		else {
		/* w.key cade nell'intervallo, quindi bisogna incrementare
		nchiavi e proseguire nei sottoalberi sx e dx */
			nchiavi = 1 + lcaVisit(w.leftChild, lower, upper);
			nchiavi += lcaVisit(w.rightChild, lower, upper);
			return nchiavi;
		}
	}
			
	/* int nrange(BSTNode u, BSTNode v) {
		restituisce no. chiavi comprese nell'
		intervallo [u.key..v.key] 
		return 0;
	} */
}